---
title: Lazy loading
slug: Web/Performance/Lazy_loading
tags:
  - Content
  - Images
  - Layout
  - Lazy
  - Lazy-loading
  - Loading
  - Performance
  - Web Performance
  - rendering
---
<p><span class="seoSummary"><strong>Lazy loading </strong><span>is a strategy to identify resources as non-blocking (non-critical) and load these only when needed. It's a way to shorten the length of the </span><a href="/en-US/docs/Web/Performance/Critical_rendering_path">critical rendering path</a><span>, which translates into reduced page load times.</span></span></p>

<p>Lazy loading can occur on different moments in the application, but it typically happens on some user interactions such as scrolling and navigation. </p>

<h2 id="Overview"><span>Overview</span></h2>

<p>As the web has evolved, we have come to see huge increases in the number and size of assets sent to users.<br>
 Between 2011 and 2019, the median resource weight increased from <strong>~100KB</strong> to <strong>~400KB</strong> for desktop and <strong>~50KB</strong> to <strong>~350KB</strong> for mobile. While Image size has increased from <strong>~250KB</strong> to <strong>~900KB</strong> on desktop and <strong>~100KB</strong> to <strong>~850KB</strong> on mobile.</p>

<p>One of the methods we can use to tackle this problem is to shorten the <a href="/en-US/docs/Web/Performance/Critical_rendering_path">Critical Rendering Path</a> length by lazy loading resources that are not critical for the first render to happen.<br>
 A practical example would be when, you land on the home page of an e-commerce site which has a link to a cart page/section and all its resources (JS, CSS, images...) are downloaded <strong>only</strong> when the user navigates to that cart page.</p>

<h2 id="Strategies">Strategies</h2>

<p>Lazy loading can be applied to multiple resources and through multiple strategies.   </p>

<h3 id="General">    General</h3>

<p id="Code_splitting"><strong>Code splitting</strong><br>
 JavaScript, CSS and HTML can be split into smaller chunks. This enables sending the minimal code required to provide value upfront, improving page-load times. The rest can be loaded on demand.</p>

<ul>
 <li>    Entry point splitting: separates code by entry point(s) in the app</li>
 <li>    Dynamic splitting: separates code where <a href="/en-US/docs/Web/JavaScript/Reference/Statements/import">dynamic import()</a> statements are used</li>
</ul>

<h3 id="JavaScript">    JavaScript</h3>

<p><strong>Script type module</strong><br>
 Any script tag with <code>type="module"</code> is treated like a <a href="/en-US/docs/Web/JavaScript/Guide/Modules">JavaScript module</a> and is deferred by default.</p>

<h3 id="CSS">    CSS</h3>

<p>By default, CSS is treated as a <a href="/en-US/docs/Web/Performance/Critical_rendering_path">render blocking</a> resource, so the browser won't render any processed content until the <a href="/en-US/docs/Web/API/CSS_Object_Model">CSSOM</a> is constructed. CSS must be thin, delivered as quickly as possible, and the usage media types and queries are advised to unblock rendering.</p>

<pre class="notranslate">&lt;link href="style.css"    rel="stylesheet" media="all"&gt;
&lt;link href="portrait.css" rel="stylesheet" media="orientation:portrait"&gt;
&lt;link href="print.css"    rel="stylesheet" media="print"&gt;
</pre>

<p>It is possible to perform some <a href="/en-US/docs/Learn/Performance/CSS">CSS optimizations</a>  to achieve that.</p>

<h3 id="Fonts">Fonts</h3>

<p>By default, font requests are delayed until the render tree is constructed, which can result in delayed text rendering.</p>

<p>It is possible to override the default behaviour and preload web font resources using <code>&lt;link rel="preload"&gt;</code>, the <a href="/en-US/docs/Web/CSS/@font-face/font-display">CSS font-display property</a>, and the <a href="/en-US/docs/Web/API/CSS_Font_Loading_API">Font Loading API</a>.<br>
 <br>
 See also: <a href="/en-US/docs/Web/HTML/Element/link">Element Link</a></p>

<h3 id="Images_and_iframes">Images and iframes</h3>

<p>Very often, webpages contain many images that contribute to data-usage and how fast a page can load. Most of those images are off-screen (<a href="/en-US/docs/Web/Performance/Critical_rendering_path">non-critical</a>), requiring user interaction (an example being scroll) in order to view them.</p>

<p><strong>Loading attribute</strong><br>
 The {{htmlattrxref("loading", "img")}} attribute on an {{HTMLElement("img")}} element (or the {{htmlattrxref("loading", "iframe")}} attribute on an {{HTMLElement("iframe")}}) can be used to instruct the browser to defer loading of images/iframes that are off-screen until the user scrolls near them.</p>

<pre class="notranslate">&lt;img src="image.jpg" alt="..." loading="lazy"&gt;
&lt;iframe src="video-player.html" title="..." loading="lazy"&gt;&lt;/iframe&gt;</pre>

<p>The <code>load</code> event fires when the eagerly-loaded content has all been loaded; at that time, it's entirely possible (or even likely) that there may be lazily-loaded images that are within the {{Glossary("visual viewport")}} that haven't yet loaded.</p>

<p>You can determine if a given image has finished loading by examining the value of its Boolean {{domxref("HTMLImageElement.complete", "complete")}} property.</p>

<p><strong>Polyfill</strong><br>
 Include this polyfill to provide support for older and currently incompatible browsers:<br>
 <a href="https://github.com/mfranzke/loading-attribute-polyfill" rel="noopener">loading-attribute-polyfill</a></p>

<p><strong>Intersection Observer API</strong><br>
 <a href="/en-US/docs/Web/API/IntersectionObserver">Intersection Observers</a> allow the user to know when an observed element enters or exits the browser’s viewport.</p>

<p><strong>Event handlers</strong><br>
 When browser compatibility is crucial, there are a few options:</p>

<ul>
 <li><a href="https://github.com/w3c/IntersectionObserver">polyfill intersection observer</a></li>
 <li>fallback to scroll, resize or orientation change event handlers to determine if a specific element is in viewport</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th><strong>Specification</strong></th>
   <th><strong>Status</strong></th>
   <th><strong>Comment</strong></th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#lazy-loading-attributes")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://developers.google.com/web/fundamentals/performance/critical-rendering-path/render-blocking-css">Render blocking CSS</a></li>
 <li><a href="https://developers.google.com/web/fundamentals/performance/optimizing-content-efficiency/webfont-optimization#optimizing_loading_and_rendering">Optimizing loading and rendering</a></li>
 <li><a href="https://developers.google.com/web/fundamentals/performance/lazy-loading-guidance/images-and-video">Lazy loading images and video</a></li>
</ul>

